/*
   -   +  GapPoints
iCustom(
   string symbol,       //    (NULL- )
   int timeframe,       // - (0- )
   "iDeMarker.Gap",     //   
   //
   int period,          //  
   int GapPoints,       //     .
   //
   int mode,            // mode -   :(0)
   int shift            // 
   );

==============

iCustom(NULL,0,"iDeMarker.Gap",DeMperiod,GapPoints, 0,i);
*/

#property indicator_separate_window 
#property indicator_buffers 1
#property indicator_color1 LightSeaGreen 
#property indicator_maximum 1
#property indicator_minimum 0
#property indicator_level1 0.3
#property indicator_level2 0.7
//  
extern int DeMperiod=14; // 
extern int GapPoints=0; //     .
 int GapHours=8; //      (>0)    (<0)
//  
double   Ind[], //  
         Max[], //   
         Min[]; //   

void init() {
   string short_name="DeM("+DeMperiod+")";
   IndicatorShortName(short_name);   
   // 
   SetIndexBuffer(0,Ind); //  
   SetIndexLabel(0,short_name);
   IndicatorBuffers(3); 
   SetIndexBuffer(1,Max); //   
   SetIndexBuffer(2,Min); //   
  }

void start() {
   //  
   int limit=Bars-IndicatorCounted()-1;  
   if(limit>1) limit=Bars-1; 
   //    
   for(int i=limit; i>=0; i--) {
      double base=iCustom(NULL,0,"KillGap",GapPoints,GapHours,0,1,i); //  
      Max[i]=High[i]+base; //   
      Min[i]=Low[i] +base; //   
     }
   //  
   for(i=limit; i>=0; i--) {
      double dH=0,dL=0;
      for(int j=i+DeMperiod-1; j>=i; j--) {
         double mx=Max[j]-Max[j+1]; //   High
         double mn=Min[j+1]-Min[j]; //   Low
         if(mx>0) dH+=mx;
         if(mn>0) dL+=mn;
        }
      double slh=dH+dL;
      if(slh==0) Ind[i]=0.5;
      else Ind[i]=(1+(dH-dL)/slh)/2;
     }
  }

